// bringt fft werte in den fft Raum für autocorrelation
arm_cfft_radix4_instance_f32 fft_inst;
arm_cfft_radix4_instance_f32 ifft_inst;
//int16_t buffer[laengeBufferAuto] __attribute__ ((aligned (4))); //buffer mit fester laenge, doppelt so gross, wie die anzahl der stichproben des arrays, platz fuer 0 dazwischen
//uint32_t output[laengeBufferAuto / 4] __attribute__ ((aligned (4)));// amplitude des ergebnisses

//um werte von vorheriger fft in buffer zu packen
void calculate(float* array) { 
  for (int i = 0; i < laengeBufferAuto; i = i + 2) {
    //double z = cos(a * i / 2) * 1000;
    buffer[i] = array[i / 2];
  }
}

void initialisiereFFT() {
  arm_cfft_radix4_init_f32(&fft_inst, laengeBufferAuto / 2, 0, 1); //initialisieren der umrechenfunktionalitaet
  arm_cfft_radix4_init_f32(&ifft_inst, laengeBufferAuto / 2, 1, 1); //initialisieren der umrechenfunktionalitaet
}

//benutze Festkommaarithmetik um window function
//um fft buffer mit window funktion zu multiplizieren
static void apply_window_to_fft_buffer(void *buffer, const void *window) 
{
  int16_t *buf = (int16_t *)buffer;
  const int16_t *win = (int16_t *)window;;

  for (int i = 0; i < 1024; i++) {
    int32_t val = *buf * *win++;
    //*buf = signed_saturate_rshift(val, 16, 15);
    *buf = val >> 15;          //ergebnis um 15 binaere nachkommastellen nach hinten verschieben
    buf += 2;
  }

}

void computeFft(const int16_t *window) {
  //if (window) apply_window_to_fft_buffer(buffer, window);
  //Serial.println("window");
  arm_cfft_radix4_f32(&fft_inst, buffer); //durchfuehrung fft
  //Serial.println("winsow2");
  //berechne absolutbeträge der sinus und cosinus anteile 
  /*for (int i = 0; i < anzahlZeitpunkte/2; i++) {
    uint32_t tmp = *((uint32_t *)buffer + i); // real & imag /
    uint32_t magsq = multiply_16tx16t_add_16bx16b(tmp, tmp); //addition des quadrats
    output[i] = magsq;
  }*/
}
void computeIFft(const int16_t *window) {
  //if (window) apply_window_to_fft_buffer(buffer, window);
  arm_cfft_radix4_f32(&ifft_inst, buffer);} //durchfuehrung ifft 
  //berechne absolutbeträge der sinus und cosinus anteile 
  /*for (int i = 0; i < anzahlZeitpunkte/2; i++) {
    uint32_t tmp = *((uint32_t *)buffer + i); // real & imag /
    uint32_t magsq = multiply_16tx16t_add_16bx16b(tmp, tmp); //addition des quadrats
    output[i] = magsq;
  }*/


